/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoPuntoVenta;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Listheader;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaTipoPuntoVentaController")
@Scope("prototype")
public class BusquedaTipoPuntoVentaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoPuntoVenta> plwTipoPuntoVenta;
    private MyListbox tipoPuntoVentaList;
    private Paging pagingTipoPuntoVenta;
    private Textbox txtNome;
    private Textbox txtEquivalenciaTPV;
    private Row rowEquivalencia;
    private Listheader headerEquivalencia;

    public Paging getPagingTipoPuntoVenta() {
        return pagingTipoPuntoVenta;
    }

    public void setPagingTipoPuntoVenta(Paging pagingTipoPuntoVenta) {
        this.pagingTipoPuntoVenta = pagingTipoPuntoVenta;
    }

    public MyListbox getTipoPuntoVentaList() {
        return tipoPuntoVentaList;
    }

    public void setTipoPuntoVentaList(MyListbox tipoPuntoVentaList) {
        this.tipoPuntoVentaList = tipoPuntoVentaList;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    public Listheader getHeaderEquivalencia() {
        return headerEquivalencia;
    }

    public void setHeaderEquivalencia(Listheader headerEquivalencia) {
        this.headerEquivalencia = headerEquivalencia;
    }

    public Row getRowEquivalencia() {
        return rowEquivalencia;
    }

    public void setRowEquivalencia(Row rowEquivalencia) {
        this.rowEquivalencia = rowEquivalencia;
    }

    public Textbox getTxtEquivalenciaTPV() {
        return txtEquivalenciaTPV;
    }

    public void setTxtEquivalenciaTPV(Textbox txtEquivalenciaTPV) {
        this.txtEquivalenciaTPV = txtEquivalenciaTPV;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tipoPuntoVentaList.setItemRenderer(new RenderTipoPuntoVenta());
        tipoPuntoVentaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoPuntoVenta tpv = (TipoPuntoVenta) tipoPuntoVentaList.getSelected();
                verTipoPuntoVenta(tpv);
            }
        });

        refreshLista();

        if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
            rowEquivalencia.setVisible(Boolean.FALSE);
            headerEquivalencia.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    private void verTipoPuntoVenta(TipoPuntoVenta tpv) {
        if (tpv == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tipoPuntoVenta", tpv);
        args.put("tipoPuntoVentaList", tipoPuntoVentaList);

        openWindow("/gui/catalogos/editarTipoPuntoVenta.zul",
                Labels.getLabel("editarTipoPuntoVentaController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<TipoPuntoVenta> claseServicioBusqueda =
                new HibernateSearchObject<TipoPuntoVenta>(TipoPuntoVenta.class,
                pagingTipoPuntoVenta.getPageSize());

        claseServicioBusqueda.addFilterLike("desctipo",
                "%" + txtNome.getText().trim().concat("%"));

        if (!txtEquivalenciaTPV.getText().isEmpty()) {
            claseServicioBusqueda.addFilterLike("equivalenciaId", txtEquivalenciaTPV.getText().trim().concat("%"));
        }

        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);
        claseServicioBusqueda.addSortAsc("desctipo");
        claseServicioBusqueda.addFilterNotEqual("tipoptovtaId", -1);

        plwTipoPuntoVenta.init(claseServicioBusqueda, tipoPuntoVentaList,
                pagingTipoPuntoVenta);

        if (tipoPuntoVentaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTipoPuntoVentaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoPuntoVenta(new TipoPuntoVenta());
    }
}
